org.apache.lucene.analysis.cn.smart

## Class SmartChineseAnalyzer

- java.lang.Object
- - org.apache.lucene.analysis.Analyzer
  - - org.apache.lucene.analysis.cn.smart.SmartChineseAnalyzer

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public final class SmartChineseAnalyzer
      extends Analyzer

  SmartChineseAnalyzer is an analyzer for Chinese or mixed Chinese-English text. The analyzer uses probabilistic knowledge to find the optimal word segmentation for Simplified Chinese text. The text is first broken into sentences, then each sentence is segmented into words.

  Segmentation is based upon the Hidden Markov Model. A large training corpus was used to calculate Chinese word frequency probability.

  This analyzer requires a dictionary to provide statistical data. SmartChineseAnalyzer has an included dictionary out-of-box.

  The included dictionary data is from ICTCLAS1.0. Thanks to ICTCLAS for their hard work, and for contributing the data under the Apache 2 License!

  Since:
    3.1
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

      `Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.analysis.Analyzer

      `GLOBAL_REUSE_STRATEGY, PER_FIELD_REUSE_STRATEGY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SmartChineseAnalyzer()` Create a new SmartChineseAnalyzer, using the default stopword list.
    `SmartChineseAnalyzer(boolean useDefaultStopWords)` Create a new SmartChineseAnalyzer, optionally using the default stopword list.
    `SmartChineseAnalyzer(CharArraySet stopWords)` Create a new SmartChineseAnalyzer, using the provided `Set` of stopwords.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Analyzer.TokenStreamComponents` | `createComponents(String fieldName)`
    `static CharArraySet` | `getDefaultStopSet()` Returns an unmodifiable instance of the default stop-words set.
    `protected TokenStream` | `normalize(String fieldName, TokenStream in)`

    - ### Methods inherited from class org.apache.lucene.analysis.Analyzer

      `attributeFactory, close, getOffsetGap, getPositionIncrementGap, getReuseStrategy, getVersion, initReader, initReaderForNormalization, normalize, setVersion, tokenStream, tokenStream`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SmartChineseAnalyzer

          public SmartChineseAnalyzer()

      Create a new SmartChineseAnalyzer, using the default stopword list.

    - #### SmartChineseAnalyzer

          public SmartChineseAnalyzer(boolean useDefaultStopWords)

      Create a new SmartChineseAnalyzer, optionally using the default stopword list.

      The included default stopword list is simply a list of punctuation. If you do not use this list, punctuation will not be removed from the text!

      Parameters:
        `useDefaultStopWords` - true to use the default stopword list.

    - #### SmartChineseAnalyzer

          public SmartChineseAnalyzer(CharArraySet stopWords)

      Create a new SmartChineseAnalyzer, using the provided `Set` of stopwords.

      Note: the set should include punctuation, unless you want to index punctuation!

      Parameters:
        `stopWords` - `Set` of stopwords to use.

  - ### Method Detail

    - #### getDefaultStopSet

          public static CharArraySet getDefaultStopSet()

      Returns an unmodifiable instance of the default stop-words set.
      Returns:
        an unmodifiable instance of the default stop-words set.

    - #### createComponents

          public Analyzer.TokenStreamComponents createComponents(String fieldName)

      Specified by:
        `createComponents` in class `Analyzer`

    - #### normalize

          protected TokenStream normalize(String fieldName,
                                          TokenStream in)

      Overrides:
        `normalize` in class `Analyzer`

Copyright © 2000-2024 Apache Software Foundation. All Rights Reserved.